## frama-c 20081201.dfsg

=== src/dummy/hello_world/Makefile ===
# Generic Makefile for bytecode plugins

FRAMAC_SHARE=$(shell frama-c -print-path)
PLUGIN_NAME=hello
PLUGIN_SRC=hello_world.ml

include $(FRAMAC_SHARE)/Makefile.template

=== src/dummy/untyped_metrics/Makefile ===
# Generic Makefile for bytecode plugins

FRAMAC_SHARE=/usr/local/share/frama-c

PLUGIN_NAME=untyped_metrics
PLUGIN_SRC=count_for.ml

include $(FRAMAC_SHARE)/Makefile.template

## frama-c 20090902+beryllium+dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2009                                               #
#    CEA   (Commissariat  l'nergie Atomique)                           #
#    INRIA (Institut National de Recherche en Informatique et en         #
#           Automatique)                                                 #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version v2.1                #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

MAKECONFIG_DIR=share

include share/Makefile.common

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin files are stored
PLUGIN_LIB_DIR	= lib/plugins
PLUGIN_GUI_LIB_DIR= lib/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# set it to yes to tell Makefile.dynamic than we come from here
FRAMAC_MAKE	=yes

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_DYN_EXISTS:="no"
PLUGIN_DYN_LIST :=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_DEP_GUI_CMO_LIST:=
PLUGIN_DEP_GUI_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_GENERATED_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

###############################
# Additional global variables #
###############################

# put here any config option for the binary distribution outside of
# plugins
CONFIG_DISTRIB_BIN:=

# additional compilation targets for 'make all'.
# cannot be delayed after 'make all'
EXTRAS	= ptests

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories containing some source code
SRC_DIRS+= $(FRAMAC_SRC_DIRS)

# Directories to include when compiling
INCLUDES=$(addprefix -I , $(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR) -I lib

# Directories to include for ocamldep
INCLUDES_FOR_OCAMLDEP= $(patsubst +%,.,$(INCLUDES) $(GUI_INCLUDES))

# Ocamldep flags
DEP_FLAGS= $(INCLUDES_FOR_OCAMLDEP)

# Files for which dependencies are computed
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
		$(addsuffix /*.mli, $(UNPACKED_DIRS)) \
		$(addsuffix /*.ml, $(UNPACKED_DIRS))

# Flags to use by ocamlc and ocamlopt
BFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE)
OFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT)

BLINKFLAGS = $(BFLAGS) -linkall -custom
OLINKFLAGS = $(OFLAGS) -linkall

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
BYTE_LIBS = nums.cma unix.cma bigarray.cma str.cma dynlink.cma \
	$(GEN_BYTE_LIBS)
OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa

ifeq ("$(NATIVE_DYNLINK)","yes")
OPT_LIBS+= dynlink.cmxa
endif

OPT_LIBS+= $(GEN_OPT_LIBS)

# files to be included in the distribution.
# plugins may add some files to this list if they include files that are
# not in $PLUGIN_DIR
DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in cil/LICENSE	\
      cil/CHANGES cil/doc/*.html cil/doc/*.tex cil/doc/*.gif		\
      share/frama-c.rc man/frama-c.1 cil/doc/*.pdf cil/doc/api/*.html	\
      cil/doc/examples/*.txt doc/manuals/*.pdf doc/README		\
      doc/code/*.ml* doc/code/*.css doc/code/*.txt			\
      doc/code/toc_head.htm doc/code/toc_tail.htm tests/*/*.c		\
      tests/*/*.h tests/*/*.ml ptests/*.ml*				\
      tests/wp/test_config_dev.system_why				\
      tests/wp/test_config_dev.local_why configure.in Makefile		\
      share/Makefile.plugin configure share/Makefile.dynamic		\
      share/Makefile.dynamic_config.internal				\
      share/Makefile.dynamic_config.external Changelog config.h.in	\
      VERSION $(filter-out CVS,licenses/*) share/*.c share/*.h		\
      share/configure.ac share/Makefile.config.in			\
      share/Makefile.common share/Makefile.plugin			\
      share/Makefile.dynamic 						\
      share/why/*.why share/why/Makefile share/why/*.why.src		\
      $(filter-out %kui%,src/kernel/*.ml*) external/ptmap.ml*		\
      external/unmarshal*.ml* src/ai/*.ml* src/buckx/*.ml*		\
      src/buckx/*.c src/gui/*.ml* src/lib/*.ml* src/logic/*.ml*		\
      src/memory_state/*.ml* src/misc/*.ml* src/project/*.ml*		\
      src/toplevel/*.ml* bin/sed_get_make_major bin/sed_get_make_minor	\
      bin/sed_inplace INSTALL .make-clean .make-clean-stamp		\
      .make-ocamlgraph-stamp

################
# Main targets #
################

ifneq ($(ENABLE_GUI),no)
ifeq ($(HAS_LABLGTK),yes)
EXTRAS	+= gui
endif
endif

all:: byte $(EXTRAS) $(OCAMLBEST) share/Makefile.dynamic_config \
      share/Makefile.kernel
	for plugin in $(EXTERNAL_PLUGINS); do \
	$(MAKE) FRAMAC_LIBDIR=$(FRAMAC_SRC)/lib/fc FRAMAC_SHARE=$(FRAMAC_SRC)/share -C $$plugin all; \
	done

clean::
	$(PRINT_RM) $(OBJ_PERFCOUNT)
	$(RM) $(OBJ_PERFCOUNT)
	for plugin in $(EXTERNAL_PLUGINS); do \
	$(MAKE) FRAMAC_LIBDIR=$(FRAMAC_SRC)/lib/fc FRAMAC_SHARE=$(FRAMAC_SRC)/share -C $$plugin clean; \
	done

.PHONY: top opt byte dist bdist archclean rebuild
top: bin/toplevel.top$(EXE)
byte: bin/toplevel.byte$(EXE)
opt: bin/toplevel.opt$(EXE)

dist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" all
bdist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" byte

ifneq ("$(OCAMLGRAPH_LOCAL)","")
archclean: clean
	$(PRINT_RM) ocamlgraph
	$(QUIET_MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
	$(PRINT_CONFIG) ocamlgraph
	cd $(OCAMLGRAPH_LOCAL) ; ./configure

rebuild: archclean
	$(PRINT_BUILD) ocamlgraph
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(PRINT_BUILD) all
	$(QUIET_MAKE) all
else
archclean: clean

rebuild: archclean
	$(PRINT_BUILD) all
	$(QUIET_MAKE) all
endif

############
# Coverage #
############

USE_COVERAGE_TOOL=no
ifeq ($(USE_COVERAGE_TOOL),yes)
COVERAGE_PATH=.
COVERAGE_PREPRO=camlp4o -no_quot -filter $(COVERAGE_PATH)/coverage_filter.cmo
COVERAGE_COMPILER_BYTE=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_COMPILER_OPT=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_LIB_BYTE=coverage.cma
COVERAGE_LIB_OPT=coverage.cmxa
endif

INCLUDES+=$(COVERAGE_COMPILER_BYTE)
GEN_BYTE_LIBS+=$(COVERAGE_LIB_BYTE)
GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
SRC_DIRS+=$(COVERAGE_PATH)

##############
# Ocamlgraph #
##############

ifneq ("$(OCAMLGRAPH_LOCAL)","")

lib/graph.cmi: .make-ocamlgraph $(wildcard $(OCAMLGRAPH_LOCAL)/src/*.ml*) \
		$(OCAMLGRAPH_LOCAL)/Makefile
	$(PRINT_BUILD) ocamlgraph
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

GENERATED+= lib/graph.cmo lib/graph.cmi
ifneq ($(OCAMLOPT),no)
GENERATED+= lib/graph.cmx lib/graph.o
endif

GRAPH_BYTE_LIBS=lib/graph.cmo
GRAPH_OPT_LIBS=lib/graph.cmx
GEN_BYTE_LIBS+=$(GRAPH_BYTE_LIBS)
GEN_OPT_LIBS+=$(GRAPH_OPT_LIBS)

.PRECIOUS: .cmo .cmi .cmx .o .cmxa .cma

# viewgraph and  dgraph (included in ocamlgraph)
ifeq ($(HAS_GNOMECANVAS),yes)

lib/viewgraph.cmi: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/dgraph.cmi: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

GRAPH_GUICMO= lib/dgraph.cmo lib/viewgraph.cmo
GRAPH_GUICMI= $(GRAPH_GUICMO:.cmo=.cmi)
GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
GRAPH_GUIO=  $(GRAPH_GUICMO:.cmo=.o)
GENERATED+= $(GRAPH_GUICMI) $(GRAPH_GUICMO)
ifneq ($(OCAMLOPT),no)
GENERATED+= $(GRAPH_GUICMX) $(GRAPH_GUIO)
endif

GEN_BYTE_GUI_LIBS+=$(GRAPH_GUICMO)
GEN_OPT_GUI_LIBS+=$(GRAPH_GUICMX)

HAS_VIEWGRAPH=yes
HAS_DGRAPH=yes

else # viewgraph and dgraph are not available
HAS_DGRAPH=no
endif

else # does not use ocamlgraph local version

INCLUDES+=$(OCAMLGRAPH)
BYTE_LIBS+= graph.cma
OPT_LIBS+= graph.cmxa

# viewgraph and dgraph (included in ocamlgraph)
ifeq ($(HAS_GNOMECANVAS),yes)
GRAPH_GUICMO_BASE= dgraph.cmo viewgraph.cmo
GRAPH_GUICMO=$(GRAPH_GUICMO_BASE:%=$(OCAMLGRAPH_HOME)/%)
GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
GRAPH_GUIO= $(GRAPH_GUICMO:.cmo=.o)
HAS_DGRAPH=yes
else # viewgraph and dgraph not available
HAS_DGRAPH=no
endif

endif # testing ocamlgraph is local

# If 'make untar-ocamlgraph' have to be performed after 'cvs update':
# change '.make-ocamlgraph-stamp' before 'cvs commit'
.make-ocamlgraph: .make-ocamlgraph-stamp
	touch $@
# Inline the rules of "untar-ocamlgraph" here 
# because calling a recursive make does not work
	$(PRINT_UNTAR) ocamlgraph
	$(RM) -r $(OCAMLGRAPH_LOCAL)
	$(TAR) xzf ocamlgraph.tar.gz
	cd $(OCAMLGRAPH_LOCAL) && ./configure

include .make-ocamlgraph
DISTRIB_FILES += .make-ocamlgraph

# force "make untar-ocamlgraph" to be executed for all users of CVS
force-ocamlgraph:
	expr `$(CAT) .make-ocamlgraph-stamp` + 1 > .make-ocamlgraph-stamp

.PHONY: untar-ocamlgraph
untar-ocamlgraph:
	$(PRINT_UNTAR) $@
	$(RM) -r $(OCAMLGRAPH_LOCAL)
	$(TAR) xzf $<
	cd $(OCAMLGRAPH_LOCAL) && ./configure

##################
# Frama-C Kernel #
##################

# Dynlink library
#################

GENERATED += src/lib/dynlink_common_interface.ml

ifeq ($(HAS_OCAML311),yes) # ocaml >= 3.11

ifeq ($(USABLE_NATIVE_DYNLINK),yes) # native dynlink works

src/lib/dynlink_common_interface.ml: src/lib/dynlink_311_or_higher.ml \
		share/Makefile.config Makefile
	$(PRINT_MAKING) $@
	$(CP) $< $@
	$(CHMOD_RO) $@

else # ocaml >= 3.11 but native dynlink doesn't work

ifeq ($(NATIVE_DYNLINK),yes) # native dynlink does exist but doesn't work

=== share/why/Makefile ===
# This Makefile build why model files because it seems that [why]
# looks for included files only in its installation directory.
# So, a workaround is to simulate inclusion.

# define those variables is they are not to be able to use make locally.
WP_LIB_DIR?=.
PRINT_MAKING?= echo 'Generating  '#
WHY_BUILD?=
WHYBIN?=why
WHYDPBIN?=why-dp

WP_LIB_BASE= types acsl model0 model1 model2 low-level
WP_LIB_FILES= $(WP_LIB_BASE:%=$(WP_LIB_DIR)/%.why)

WP_LIB_TESTS = $(WP_LIB_BASE:%=$(WP_LIB_DIR)/test_%.why)
WP_LIB_OK = $(WP_LIB_TESTS:%.why=%.ok)

wp_lib : $(WP_LIB_OK)

types_FILES=$(WP_LIB_DIR)/types.why
acsl_FILES=$(types_FILES) $(WP_LIB_DIR)/acsl.why
model0_FILES=$(acsl_FILES) $(WP_LIB_DIR)/model0.why
model1_FILES=$(model0_FILES) $(WP_LIB_DIR)/model1.why
model2_FILES=$(model1_FILES) $(WP_LIB_DIR)/model2.why
low-level_FILES=$(acsl_FILES) $(WP_LIB_DIR)/low-level.why



#==== TESTS :

$(WP_LIB_TESTS) : $(WP_LIB_FILES)

$(WP_LIB_DIR)/test_%.why : $(WP_LIB_DIR)/test_%.why.src
	$(PRINT_MAKING) $@
	@echo "(* Generated file : see $< *)" > $@
	cat $($*_FILES) >> $@
	cat $@.src >> $@

%_why.why : %.why $(WHY_BUILD)
	$(PRINT_MAKING) $@
	$(WHYBIN) --why $<

%.log : %_why.why
	$(PRINT_MAKING) $@
	$(WHYDPBIN) -no-timings $< > $@ 2>&1

.PRECIOUS : $(WP_LIB_TESTS) $(WP_LIB_OK:%.ok=%.oracle) $(WP_LIB_OK:%.ok=%.log)

%.ok : %.log %.oracle
	$(PRINT_MAKING) $@
	@if diff $*.oracle $*.log > /dev/null ; then \
          echo "Bravo... Test [32mOk[0m" ; \
          touch $@ ; \
        else \
          echo "[31mDIFFERENCES[0m : diff $*.oracle $*.log" ; \
          echo "Pour forcer une nouvelle execution du test :" ; \
          echo "  rm $*.log ; make $*.ok"; \
          echo "[31mPour accepter faire[0m : " ; \
          echo "  cp $*.log $*.oracle" ; \
          rm -f $@ ; \
        fi

%.oracle :
	$(PRINT_MAKING) $@
	echo "	[31m[ATTENTION : gnration automatique d'oracle][0m"
	$(MAKE) $*.log
	cp $*.log $*.oracle


#==== CLEAN :

clean::
	rm -f $(WP_LIB_OK)
	rm -f $(WP_LIB_BASE:%=$(WP_LIB_DIR)/%_why.why)
	rm -f $(WP_LIB_OK) $(WP_LIB_OK:%.ok=%.why)
	rm -f $(WP_LIB_OK) $(WP_LIB_OK:%.ok=%.log)

#==== END.

=== src/ltl_to_acsl/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2009                                               #
#    INSA  (Institut National des Sciences Appliquees)                   #
#    INRIA (Institut National de Recherche en Informatique et en         #
#           Automatique)                                                 #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Makefile for compiling Aorai independently of Frama-C.
#
# To be used independently of Frama-C, a version of Frama-C compatible with
# Aorai has to be properly installed as long as the Aorai-specific stuff.

# Do not use ?= to initialize both below variables 
# (fixed efficiency issue, see GNU Make manual, Section 8.11)
ifndef FRAMAC_SHARE
FRAMAC_SHARE  :=$(shell frama-c -journal-disable -print-path)
endif
ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR :=$(shell frama-c -journal-disable -print-libpath)
endif
PLUGIN_DIR ?=.

PLUGIN_NAME:=Ltl_to_acsl
PLUGIN_GENERATED:= $(addprefix ${PLUGIN_DIR}/, \
		promelalexer_withexps.ml promelaparser_withexps.ml \
		promelaparser_withexps.mli \
		promelalexer.ml promelaparser.ml promelaparser.mli \
		ltllexer.ml ltlparser.ml ltlparser.mli \
		yalexer.ml yaparser.ml yaparser.mli)
PLUGIN_CMO:= bool3 \
	spec_tools \
	ltl_to_acsl_option \
	data_for_ltl \
	promelaoutput \
	ltl_logic \
	ltl_utils \
	ltl_output \
	utils_parser \
	ltlparser \
	ltllexer \
	yaparser \
	yalexer \
	promelaparser \
	promelalexer \
	promelaparser_withexps \
	promelalexer_withexps \
	abstract_ai \
	bycase_ai \
	ltl_to_acsl_visitors \
	ltl_to_acsl_register
PLUGIN_CMI:= ltlast \
	promelaast
PLUGIN_HAS_MLI:=yes
PLUGIN_DISTRIBUTED:=yes
PLUGIN_DISTRIB_BIN:=no
# if ltltoba is not present, do not attempt to run the tests by default.
ifneq ("$(HAS_LTLTOBA)","yes")
PLUGIN_NO_DEFAULT_TEST:=yes
endif

include $(FRAMAC_SHARE)/Makefile.dynamic

=== src/dummy/hello_world/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2009                                               #
#    CEA (Commissariat  l'nergie Atomique)                             #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Example of Makefile for dynamic plugins
#########################################

# Frama-c should be properly installed with "make install" 
# before any use of this makefile

FRAMAC_SHARE=$(shell frama-c.byte -print-path)
FRAMAC_LIBDIR=$(shell frama-c.byte -print-libpath)
PLUGIN_NAME=Hello
PLUGIN_CMO=hello_world
include $(FRAMAC_SHARE)/Makefile.dynamic

=== src/dummy/untyped_metrics/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2009                                               #
#    CEA (Commissariat  l'nergie Atomique)                             #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Generic Makefile for bytecode plugins

FRAMAC_SHARE=$(shell frama-c -print-path)

PLUGIN_NAME=Untyped_metrics
PLUGIN_CMO=count_for

include $(FRAMAC_SHARE)/Makefile.dynamic

## frama-c 20100401+boron+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,8 +2,9 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2009                                               #
-#    CEA   (Commissariat  l'nergie Atomique)                           #
+#  Copyright (C) 2007-2010                                               #
+#    CEA   (Commissariat  l'nergie atomique et aux nergies            #
+#           alternatives)                                                #
 #    INRIA (Institut National de Recherche en Informatique et en         #
 #           Automatique)                                                 #
 #                                                                        #
@@ -23,6 +24,7 @@
 
 # This file is the main makefile of Frama-C.
 
+FRAMAC_SRC=.
 MAKECONFIG_DIR=share
 
 include share/Makefile.common
@@ -33,7 +35,7 @@
 
 # the directory where compiled plugin files are stored
 PLUGIN_LIB_DIR	= lib/plugins
-PLUGIN_GUI_LIB_DIR= lib/gui
+PLUGIN_GUI_LIB_DIR= lib/plugins/gui
 
 # the directory where the other Makefiles are
 FRAMAC_SHARE	= share
@@ -63,7 +65,6 @@
 PLUGIN_DYN_GUI_CMX_LIST :=
 PLUGIN_TYPES_CMO_LIST :=
 PLUGIN_TYPES_CMX_LIST :=
-PLUGIN_GENERATED_LIST :=
 PLUGIN_DEP_LIST:=
 PLUGIN_DOC_LIST :=
 PLUGIN_DOC_DIRS :=
@@ -114,8 +115,10 @@
 		$(addsuffix /*.ml, $(UNPACKED_DIRS))
 
 # Flags to use by ocamlc and ocamlopt
-BFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE)
-OFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT)
+BFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE) \
+	  $(OCAMLVIZ_COMPILER_BYTE)
+OFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT) $(GPROFOPT) \
+	  $(OCAMLVIZ_COMPILER_OPT)
 
 BLINKFLAGS = $(BFLAGS) -linkall -custom
 OLINKFLAGS = $(OFLAGS) -linkall
@@ -135,33 +138,41 @@
 
 OPT_LIBS+= $(GEN_OPT_LIBS)
 
-# files to be included in the distribution.
-# plugins may add some files to this list if they include files that are
-# not in $PLUGIN_DIR
+# Kernel files to be included in the distribution.
+# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
+# than *.ml* files in their directory.
+# NB: configure for the distribution is generated in the distrib directory
+# itself, rather than copied: otherwise, it could include references to
+# non-distributed plug-ins.
 DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in cil/LICENSE	\
       cil/CHANGES cil/doc/*.html cil/doc/*.tex cil/doc/*.gif		\
       share/frama-c.rc man/frama-c.1 cil/doc/*.pdf cil/doc/api/*.html	\
       cil/doc/examples/*.txt doc/manuals/*.pdf doc/README		\
       doc/code/*.ml* doc/code/*.css doc/code/*.txt			\
-      doc/code/toc_head.htm doc/code/toc_tail.htm tests/*/*.c		\
-      tests/*/*.h tests/*/*.ml ptests/*.ml*				\
-      tests/wp/test_config_dev.system_why				\
-      tests/wp/test_config_dev.local_why configure.in Makefile		\
-      share/Makefile.plugin configure share/Makefile.dynamic		\
-      share/Makefile.dynamic_config.internal				\
+      doc/code/toc_head.htm doc/code/toc_tail.htm 			\
+      share/frama-c.ico share/frama-c.gif				\
+      tests/*/*.c tests/*/*.h tests/*/*.ml ptests/*.ml* configure.in	\
+      Makefile share/Makefile.kernel share/Makefile.plugin		\
+      share/Makefile.dynamic share/Makefile.dynamic_config.internal	\
       share/Makefile.dynamic_config.external Changelog config.h.in	\
-      VERSION $(filter-out CVS,licenses/*) share/*.c share/*.h		\
+      VERSION $(filter-out CVS,licenses/*)              		\
+      share/*.c share/*.h share/libc/*.c share/libc/*.h                 \
+      share/libc/sys/*.h share/libc/netinet/*.h                         \
+      share/acsl.el share/frama-c.gif share/frama-c.ico                 \
+      share/known_plugins.ac                                            \
       share/configure.ac share/Makefile.config.in			\
       share/Makefile.common share/Makefile.plugin			\
-      share/Makefile.dynamic 						\
-      share/why/*.why share/why/Makefile share/why/*.why.src		\
-      $(filter-out %kui%,src/kernel/*.ml*) external/ptmap.ml*		\
-      external/unmarshal*.ml* src/ai/*.ml* src/buckx/*.ml*		\
-      src/buckx/*.c src/gui/*.ml* src/lib/*.ml* src/logic/*.ml*		\
-      src/memory_state/*.ml* src/misc/*.ml* src/project/*.ml*		\
-      src/toplevel/*.ml* bin/sed_get_make_major bin/sed_get_make_minor	\
-      bin/sed_inplace INSTALL .make-clean .make-clean-stamp		\
-      .make-ocamlgraph-stamp
+      share/Makefile.dynamic share/why/*.why share/why/Makefile		\
+      share/Makefile.dynamic_config.external                            \
+      share/Makefile.dynamic_config.internal                            \
+      share/why/*.why share/why/Makefile                 		\
+      share/why/*.why.src $(filter-out %kui%,src/kernel/*.ml*)		\
+      external/ptmap.ml* external/unmarshal*.ml* src/ai/*.ml*		\
+      src/buckx/*.ml* src/buckx/*.c src/gui/*.ml* src/lib/*.ml*		\
+      src/logic/*.ml* src/memory_state/*.ml* src/misc/*.ml*		\
+      src/project/*.ml* src/toplevel/*.ml* bin/sed_get_make_major	\
+      bin/sed_get_make_minor bin/sed_inplace INSTALL INSTALL_WITH_WHY	\
+      .make-clean .make-clean-stamp .make-ocamlgraph-stamp
 
 ################
 # Main targets #
@@ -173,46 +184,41 @@
 endif
 endif
 
-all:: byte $(EXTRAS) $(OCAMLBEST) share/Makefile.dynamic_config \
-      share/Makefile.kernel
-	for plugin in $(EXTERNAL_PLUGINS); do \
-	$(MAKE) FRAMAC_LIBDIR=$(FRAMAC_SRC)/lib/fc FRAMAC_SHARE=$(FRAMAC_SRC)/share -C $$plugin all; \
-	done
+all:: byte $(EXTRAS) $(OCAMLBEST)
 
 clean::
 	$(PRINT_RM) $(OBJ_PERFCOUNT)
 	$(RM) $(OBJ_PERFCOUNT)
-	for plugin in $(EXTERNAL_PLUGINS); do \
-	$(MAKE) FRAMAC_LIBDIR=$(FRAMAC_SRC)/lib/fc FRAMAC_SHARE=$(FRAMAC_SRC)/share -C $$plugin clean; \
-	done
 
 .PHONY: top opt byte dist bdist archclean rebuild
 top: bin/toplevel.top$(EXE)
-byte: bin/toplevel.byte$(EXE)
-opt: bin/toplevel.opt$(EXE)
+
+byte:: bin/toplevel.byte$(EXE) \
+      share/Makefile.dynamic_config share/Makefile.kernel
+	$(MAKE) install-kernel-byte FRAMAC_LIBDIR=lib/fc
+
+opt:: bin/toplevel.opt$(EXE) \
+     share/Makefile.dynamic_config share/Makefile.kernel
+	$(MAKE) install-kernel-opt FRAMAC_LIBDIR=lib/fc
 
 dist: clean
 	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" all
+
 bdist: clean
 	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" byte
 
 ifneq ("$(OCAMLGRAPH_LOCAL)","")
 archclean: clean
-	$(PRINT_RM) ocamlgraph
-	$(QUIET_MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
-	$(PRINT_CONFIG) ocamlgraph
+	$(MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
 	cd $(OCAMLGRAPH_LOCAL) ; ./configure
 
 rebuild: archclean
-	$(PRINT_BUILD) ocamlgraph
 	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
-	$(PRINT_BUILD) all
 	$(QUIET_MAKE) all
 else
 archclean: clean
 
 rebuild: archclean
-	$(PRINT_BUILD) all
 	$(QUIET_MAKE) all
 endif
 
@@ -235,6 +241,32 @@
 GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
 SRC_DIRS+=$(COVERAGE_PATH)
 
+########################
+# Ocamlviz (profiling) #
+########################
+
+# To use OCamlviz you need to fix its makefile :-(
+# In $(OCAMLVIZ_PATH)/Makefile.in change the line
+# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo src/ocamlviz_threads.cmo
+# into
+# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo
+# Then run "./configure && make" in $(OCAMLVIZ_PATH)
+# You need to set $(OCAMLVIZ_PATH) according to your own setup.
+# Only one instance of Frama-C can be launched at a time when Ocamlviz is on.
+USE_OCAMLVIZ_TOOL=no
+ifeq ($(USE_OCAMLVIZ_TOOL),yes)
+OCAMLVIZ_PATH=EXTERNAL/ocamlviz
+OCAMLVIZ_COMPILER_BYTE=-I $(OCAMLVIZ_PATH)/src
+# -pp "camlp4 pa_o.cmo str.cma $(OCAMLVIZ_PATH)/camlp4/pa_ocamlviz.cmo pr_o.cmo"
+# Seems really broken and generates fatal warnings
+OCAMLVIZ_COMPILER_OPT=-I $(OCAMLVIZ_PATH)/src
+OCAMLVIZ_LIB_BYTE=$(OCAMLVIZ_PATH)/libocamlviz.cma
+OCAMLVIZ_LIB_OPT=$(OCAMLVIZ_PATH)/libocamlviz.cmxa
+endif
+
+BYTE_LIBS+=$(OCAMLVIZ_LIB_BYTE)
+OPT_LIBS+=$(OCAMLVIZ_LIB_OPT)
+
 ##############
 # Ocamlgraph #
 ##############
@@ -334,61 +366,3 @@
 
 # viewgraph and dgraph (included in ocamlgraph)
 ifeq ($(HAS_GNOMECANVAS),yes)
-GRAPH_GUICMO_BASE= dgraph.cmo viewgraph.cmo
-GRAPH_GUICMO=$(GRAPH_GUICMO_BASE:%=$(OCAMLGRAPH_HOME)/%)
-GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
-GRAPH_GUIO= $(GRAPH_GUICMO:.cmo=.o)
-HAS_DGRAPH=yes
-else # viewgraph and dgraph not available
-HAS_DGRAPH=no
-endif
-
-endif # testing ocamlgraph is local
-
-# If 'make untar-ocamlgraph' have to be performed after 'cvs update':
-# change '.make-ocamlgraph-stamp' before 'cvs commit'
-.make-ocamlgraph: .make-ocamlgraph-stamp
-	touch $@
-# Inline the rules of "untar-ocamlgraph" here 
-# because calling a recursive make does not work
-	$(PRINT_UNTAR) ocamlgraph
-	$(RM) -r $(OCAMLGRAPH_LOCAL)
-	$(TAR) xzf ocamlgraph.tar.gz
-	cd $(OCAMLGRAPH_LOCAL) && ./configure
-
-include .make-ocamlgraph
-DISTRIB_FILES += .make-ocamlgraph
-
-# force "make untar-ocamlgraph" to be executed for all users of CVS
-force-ocamlgraph:
-	expr `$(CAT) .make-ocamlgraph-stamp` + 1 > .make-ocamlgraph-stamp
-
-.PHONY: untar-ocamlgraph
-untar-ocamlgraph:
-	$(PRINT_UNTAR) $@
-	$(RM) -r $(OCAMLGRAPH_LOCAL)
-	$(TAR) xzf $<
-	cd $(OCAMLGRAPH_LOCAL) && ./configure
-
-##################
-# Frama-C Kernel #
-##################
-
-# Dynlink library
-#################
-
-GENERATED += src/lib/dynlink_common_interface.ml
-
-ifeq ($(HAS_OCAML311),yes) # ocaml >= 3.11
-
-ifeq ($(USABLE_NATIVE_DYNLINK),yes) # native dynlink works
-
-src/lib/dynlink_common_interface.ml: src/lib/dynlink_311_or_higher.ml \
-		share/Makefile.config Makefile
-	$(PRINT_MAKING) $@
-	$(CP) $< $@
-	$(CHMOD_RO) $@
-
-else # ocaml >= 3.11 but native dynlink doesn't work
-
-ifeq ($(NATIVE_DYNLINK),yes) # native dynlink does exist but doesn't work

=== share/why/Makefile ===
--- 
+++ 
@@ -1,3 +1,27 @@
+##########################################################################
+#                                                                        #
+#  This file is part of Frama-C.                                         #
+#                                                                        #
+#  Copyright (C) 2007-2010                                               #
+#    CEA   (Commissariat  l'nergie atomique et aux nergies            #
+#           alternatives)                                                #
+#    INRIA (Institut National de Recherche en Informatique et en         #
+#           Automatique)                                                 #
+#                                                                        #
+#  you can redistribute it and/or modify it under the terms of the GNU   #
+#  Lesser General Public License as published by the Free Software       #
+#  Foundation, version 2.1.                                              #
+#                                                                        #
+#  It is distributed in the hope that it will be useful,                 #
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
+#  GNU Lesser General Public License for more details.                   #
+#                                                                        #
+#  See the GNU Lesser General Public License version v2.1                #
+#  for more details (enclosed in the file licenses/LGPLv2.1).            #
+#                                                                        #
+##########################################################################
+
 # This Makefile build why model files because it seems that [why]
 # looks for included files only in its installation directory.
 # So, a workaround is to simulate inclusion.

=== src/dummy/hello_world/Makefile ===
--- 
+++ 
@@ -2,8 +2,9 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2009                                               #
-#    CEA (Commissariat  l'nergie Atomique)                             #
+#  Copyright (C) 2007-2010                                               #
+#    CEA (Commissariat  l'nergie atomique et aux nergies              #
+#         alternatives)                                                  #
 #                                                                        #
 #  you can redistribute it and/or modify it under the terms of the GNU   #
 #  Lesser General Public License as published by the Free Software       #
@@ -25,8 +26,8 @@
 # Frama-c should be properly installed with "make install" 
 # before any use of this makefile
 
-FRAMAC_SHARE=$(shell frama-c.byte -print-path)
-FRAMAC_LIBDIR=$(shell frama-c.byte -print-libpath)
-PLUGIN_NAME=Hello
-PLUGIN_CMO=hello_world
+FRAMAC_SHARE  	:=$(shell frama-c.byte -print-path)
+FRAMAC_LIBDIR 	:=$(shell frama-c.byte -print-libpath)
+PLUGIN_NAME	= Hello
+PLUGIN_CMO	= hello_world
 include $(FRAMAC_SHARE)/Makefile.dynamic

=== src/dummy/untyped_metrics/Makefile ===
--- 
+++ 
@@ -2,8 +2,9 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2009                                               #
-#    CEA (Commissariat  l'nergie Atomique)                             #
+#  Copyright (C) 2007-2010                                               #
+#    CEA (Commissariat  l'nergie atomique et aux nergies              #
+#         alternatives)                                                  #
 #                                                                        #
 #  you can redistribute it and/or modify it under the terms of the GNU   #
 #  Lesser General Public License as published by the Free Software       #

=== debian/changelog ===
frama-c (20100401+boron+dfsg-5) unstable; urgency=low

  [ Stéphane Glondu ]
  * Fix versioned build-deps to ensure smoother backports

  [ Mehdi Dogguy ]
  * Add 0011-Fix-some-minor-memory-leaks.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 05 Oct 2010 18:49:13 +0200

frama-c (20100401+boron+dfsg-4) unstable; urgency=low

  * Add 0009-unrollType-in-handle_signed_overflow from upstream.
  * Add 0010-More-spelling-fixes.patch
  * Convert to 3.0 (quilt) source format.
  * Bump standards version to 3.9.0.

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 16 Jul 2010 13:53:55 +0200

frama-c (20100401+boron+dfsg-3) unstable; urgency=low

  * Add some patches
    - 0007-Fix-cpp-command-arguments.patch
    - 0008-Fix-ai-ival.ml-filter_ge.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 14 Jun 2010 23:36:37 +0200

frama-c (20100401+boron+dfsg-2) unstable; urgency=low

  * Make the configure script accept OCamlgraph 1.5 (Closes: #580090)
  * Build-depend on ocaml (>= 3.11.1-3~) and dh-ocaml (>= 0.9~).
  * Add a debian/source/format file (keep the package in 1.0 format,
    for now).

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 01 Jun 2010 20:18:44 +0200

frama-c (20100401+boron+dfsg-1) unstable; urgency=low

  * New upstream release:
    - Remove some patches integrated by upstream:
      + 0001-Use-GSourceView2.patch
      + 0003-Do-not-install-native-Kernel-modules-on-bytecode-arc.patch
      + 0004-temp_file-changed-in-OCaml-3.11.2.patch
    - Add some patches:
      + 0002-.make-ocamlgraph-no-op-for-non-local-ocamlgraph
      + 0003-Fix-build-on-bytecode-only-architectures.patch
      + 0004-Fix-some-typos.patch
      + 0005-Don-t-modify-system-files.patch
      + 0006-Fix-build-on-bytecode-only-architectures.patch
    - Update:
      + 0001-Fix-hyphen-used-as-minus-sign-and-a-typo.patch
    - Bump ocamlgraph minimum version to 1.4
  * Set Priority to optional
  * Set filter-pristine-tar in debian/gbp.conf
  * Fix watch file
  * Update 'Homepage' field
  * Bump Standards Version to 3.8.4, no changes needed.
  * Update copyright file

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 27 Apr 2010 16:04:49 +0200

frama-c (20090902+beryllium+dfsg-5) unstable; urgency=low

  * Build-Depend on libocamlgraph-viewer-ocaml-dev (Closes: #575371)

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 25 Mar 2010 11:14:43 +0100

frama-c (20090902+beryllium+dfsg-4) unstable; urgency=low

  * Make it compile with OCaml 3.11.2 (Closes: #569260)
    - Add 0004-temp_file-changed-in-OCaml-3.11.2.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 11 Feb 2010 20:57:17 +0100

frama-c (20090902+beryllium+dfsg-3) unstable; urgency=low

  * Fix FTBFS on bytecode architectures
    - 0003-Do-not-install-native-Kernel-modules-on-bytecode-architectures
  * Add Graphviz to build-depends

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 22 Jan 2010 11:59:37 +0100

frama-c (20090902+beryllium+dfsg-2) unstable; urgency=low

  * Fix installability problem by installing frama-c-gui.1 only once.
  * Remove empty dirs
  * Fix hyphen-used-as-minus-sign
  * Fix short description of frama-c-base
  * Set section to « devel »

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 17 Jan 2010 19:33:00 +0100

frama-c (20090902+beryllium+dfsg-1) unstable; urgency=low

  * New upstream release
    + Remove 0001-Fix-weak-pattern-matching-in-dynlink_lower_311_byte..patch
      (fixed upstream)
    + Remove 0003-Add-dGraphView.cmo-when-linking.patch (fixed upstream)
  * Update copyright file
  * Remove libjessie-ocaml-dev from build-deps (Why is not needed anymore
    to build Frama-C).
  * Run dh using "--with ocaml" to trigger dh-ocaml sequence
  * Build-depend on ocamlgraph 1.3
  * Add a new binary package: frama-c-base

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 10 Jan 2010 22:50:18 +0100

frama-c (20090901+beryllium+dfsg-2) unstable; urgency=low

  * Fix watch file
  * Build-depend on lablgtk2 (>= 2.14.0+dfsg-2) (Closes: #541963).
    - Add a patch: 0004-Use-GSourceView2.patch
  * Use new features of dh-ocaml
  * Build-dep on ocamlgraph (>> 1.2+debian)

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 02 Dec 2009 00:08:35 +0100

frama-c (20090901+beryllium+dfsg-1) unstable; urgency=low

  * Change the version number to reflect the codename in the version string
  * New Upstream Version
    + Fixes the issues related the static Jessie plugin. Thus, removing:
      0004-Add-JCCM-O-X-to-BYTE-OPT-_LIBS-when-linking-statical.patch
      (Closes: #544404).
    + Provides toc_head.htm and toc_tail.htm
    + Fixes linking problem for the viewer. Thus, removing:
      0002-Do-not-add-GRAPH_GUICMO-to-BYTE_GUI_LIBS.patch
    + Removing 0006-Do-not-install-non-existant-files.patch (now integrated
      upstream)
  * Add some patches:
    + Fix weak pattern-matching in dynlink_lower_311_byte.ml, fixes FTBFS
      on non-native architectures (Closes: #544833).
      0001-Fix-weak-pattern-matching-in-dynlink_lower_311_byte..patch
    + Make the Jessie plugin compile with Jc 2.19:
      0002-Make-Jessie-plugin-use-Jc-from-Why-2.19.patch
    + Fix linking problem for the viewer (add dGraphView.cmo):
      0003-Add-dGraphView.cmo-when-linking.patch
  * Bump libocamlgraph-ocaml-dev version from 1.1 to 1.2+debian in build
    dependencies.
  * Don't strip bytecode binaries since they are compiled with -custom
  * Recommends alt-ergo and libwhy-coq
  * Remove useless runtime dependency libocamlgraph-ocaml-dev
  * Install data needed by frama-c in /usr/share/frama-c
  * Make some additional links to follow default upstream installation:
    + /usr/share/frama-c/why      -> /usr/share/why/
    + /usr/share/frama-c/caduceus -> /usr/share/caduceus

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 09 Sep 2009 17:30:41 +0200

frama-c (20090601~beta1+dfsg-1) unstable; urgency=low

  * New Upstream Version
  * Use Debian mail address, Remove DMUA
  * Remove patches integrated upstream:
    + 0001-Gui_includes-variable-should-include-ocamlgraph-too.patch
    + 0002-Make-the-jessie-plugin-compatible-with-why-2.18.patch


=== debian/control ===
Source: frama-c
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 7.0.50~),
 ocaml-nox (>= 3.11.1-3~),
 ocaml-best-compilers,
 dh-ocaml (>= 0.9~),
 graphviz,
 libocamlgraph-viewer-ocaml-dev (>> 1.4~),
 liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
 liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
Standards-Version: 3.9.0
Homepage: http://frama-c.com/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/frama-c.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/frama-c.git

Package: frama-c
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 frama-c-base (= ${binary:Version}),
 graphviz,
 emacs | emacsen
Recommends:
 why (>= 2.19+dfsg-2),
Description: Framework for source code analysis of software written in C
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the graphical user interface of Frama-c and depends
 on frama-c-base.

Package: frama-c-base
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 gcc,
Recommends:
 alt-ergo,
 libwhy-coq
Replaces: frama-c (<< 20090902+beryllium+dfsg-1)
Breaks: frama-c (<< 20090902+beryllium+dfsg-1)
Description: Framework for C source code analysis (without gui)
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the library of Frama-c which is useful to build
 plugins for Frama-c and the command-line tools.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

FRAMA_DIR=$(CURDIR)/debian/tmp

override_dh_auto_configure:
	mkdir -p lib/plugins
	mkdir -p lib/gui
	touch .depend .make-clean .make-clean-stamp
	[ ! -f src/kernel/config.ml ] || cp src/kernel/config.ml src/kernel/config.ml.debian
	./configure $(CROSS) --prefix=/usr       \
		--mandir=\$${prefix}/share/man   \
		--infodir=\$${prefix}/share/info \
		--datarootdir=\$${prefix}/share  \
		--disable-impact		 \
		--disable-security		 \
		--enable-verbosemake             \
		CFLAGS="$(CFLAGS)"               \
		LDFLAGS="-Wl,-z,defs"

override_dh_auto_install:
	$(MAKE) prefix=$(FRAMA_DIR)/usr FRAMAC_DATADIR=$(FRAMA_DIR)/usr/share/frama-c install
	# Fix permission of .c and .h files (they don't have to be executable)
	find debian/ -name "*.c" -or -name "*.h" -exec chmod a-x '{}' \;
	cp debian/icons/frama-c.svg $(CURDIR)/debian/frama-c/usr/share/icons/hicolor/scalable/apps/
	cp debian/icons/frama-c.xpm $(CURDIR)/debian/frama-c/usr/share/pixmaps/
	cp debian/frama-c.desktop $(CURDIR)/debian/frama-c/usr/share/applications/
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c-gui.byte
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/ptests.byte
	# Same file as frama-c.1. We use a symlink instead of copying the file twice
	$(RM) -f $(FRAMA_DIR)/usr/share/man/man1/frama-c-gui.1
ifeq ($(OCAML_OPT_ARCH),)
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c.byte
endif

override_dh_strip:
# frama-c is compiled with -custom
ifdef OCAML_OPT_ARCH
	dh_strip -X frama-c-gui.byte -X frama-c.byte
endif

override_dh_auto_clean:
	touch .depend
	[ ! -f src/kernel/config.ml.debian ] || mv src/kernel/config.ml.debian src/kernel/config.ml
	[ ! -f Makefile -o ! -f share/Makefile.config ] || $(MAKE) clean
	$(RM) -rf lib .depend

%:
	dh --with ocaml $@
